import {
  useRadioGroup
} from "./chunk-A3YL5D7K.mjs";
import {
  RadioGroupProvider
} from "./chunk-NFAVX6Y6.mjs";

// src/radio-group.tsx
import { forwardRef } from "@nextui-org/system";
import { jsx, jsxs } from "react/jsx-runtime";
var RadioGroup = forwardRef((props, ref) => {
  const {
    Component,
    children,
    label,
    context,
    getGroupProps,
    getLabelProps,
    getWrapperProps
  } = useRadioGroup({ ref, ...props });
  return /* @__PURE__ */ jsxs(Component, { ...getGroupProps(), children: [
    label && /* @__PURE__ */ jsx("label", { ...getLabelProps(), children: label }),
    /* @__PURE__ */ jsx("div", { ...getWrapperProps(), children: /* @__PURE__ */ jsx(RadioGroupProvider, { value: context, children }) })
  ] });
});
RadioGroup.displayName = "NextUI.RadioGroup";
var radio_group_default = RadioGroup;

export {
  radio_group_default
};
