"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/radio-group.tsx
var radio_group_exports = {};
__export(radio_group_exports, {
  default: () => radio_group_default
});
module.exports = __toCommonJS(radio_group_exports);
var import_system = require("@nextui-org/system");

// src/radio-group-context.ts
var import_shared_utils = require("@nextui-org/shared-utils");
var [RadioGroupProvider, useRadioGroupContext] = (0, import_shared_utils.createContext)({
  name: "RadioGroupContext",
  strict: true,
  errorMessage: "useRadioGroupContext: `context` is undefined. Seems you forgot to wrap all checkbox components within `<Radio.Group />`"
});

// src/use-radio-group.ts
var import_theme = require("@nextui-org/theme");
var import_react = require("react");
var import_radio = require("@react-stately/radio");
var import_radio2 = require("@react-aria/radio");
var import_dom_utils = require("@nextui-org/dom-utils");
var import_shared_utils2 = require("@nextui-org/shared-utils");
var import_utils = require("@react-aria/utils");
function useRadioGroup(props) {
  const {
    as,
    ref,
    styles,
    children,
    label,
    size = "md",
    color = "primary",
    radius = "full",
    isDisabled = false,
    disableAnimation = false,
    orientation = "vertical",
    isRequired = false,
    validationState,
    className,
    onChange,
    onValueChange,
    ...otherProps
  } = props;
  const Component = as || "div";
  const domRef = (0, import_dom_utils.useDOMRef)(ref);
  const otherPropsWithOrientation = (0, import_react.useMemo)(() => {
    return {
      ...otherProps,
      "aria-label": typeof label === "string" ? label : otherProps["aria-label"],
      isRequired,
      orientation,
      onChange: onValueChange
    };
  }, [otherProps, onValueChange]);
  const groupState = (0, import_radio.useRadioGroupState)(otherPropsWithOrientation);
  const { labelProps, radioGroupProps: groupProps } = (0, import_radio2.useRadioGroup)(
    otherPropsWithOrientation,
    groupState
  );
  const context = (0, import_react.useMemo)(
    () => ({
      size,
      color,
      radius,
      groupState,
      isRequired,
      validationState,
      isDisabled,
      disableAnimation,
      onChange
    }),
    [
      size,
      color,
      radius,
      groupState,
      isRequired,
      validationState,
      isDisabled,
      disableAnimation,
      onChange
    ]
  );
  const slots = (0, import_react.useMemo)(() => (0, import_theme.radioGroup)(), []);
  const baseStyles = (0, import_shared_utils2.clsx)(styles == null ? void 0 : styles.base, className);
  const getGroupProps = () => {
    return {
      ref: domRef,
      className: slots.base({ class: baseStyles }),
      ...(0, import_utils.mergeProps)(groupProps, otherProps)
    };
  };
  const getLabelProps = () => {
    return {
      className: slots.label({ class: styles == null ? void 0 : styles.label }),
      ...labelProps
    };
  };
  const getWrapperProps = () => {
    return {
      className: slots.wrapper({ class: styles == null ? void 0 : styles.wrapper }),
      role: "presentation",
      "data-orientation": orientation
    };
  };
  return {
    Component,
    children,
    label,
    context,
    getGroupProps,
    getLabelProps,
    getWrapperProps
  };
}

// src/radio-group.tsx
var import_jsx_runtime = require("react/jsx-runtime");
var RadioGroup = (0, import_system.forwardRef)((props, ref) => {
  const {
    Component,
    children,
    label,
    context,
    getGroupProps,
    getLabelProps,
    getWrapperProps
  } = useRadioGroup({ ref, ...props });
  return /* @__PURE__ */ (0, import_jsx_runtime.jsxs)(Component, { ...getGroupProps(), children: [
    label && /* @__PURE__ */ (0, import_jsx_runtime.jsx)("label", { ...getLabelProps(), children: label }),
    /* @__PURE__ */ (0, import_jsx_runtime.jsx)("div", { ...getWrapperProps(), children: /* @__PURE__ */ (0, import_jsx_runtime.jsx)(RadioGroupProvider, { value: context, children }) })
  ] });
});
RadioGroup.displayName = "NextUI.RadioGroup";
var radio_group_default = RadioGroup;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
