"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/use-radio.ts
var use_radio_exports = {};
__export(use_radio_exports, {
  useRadio: () => useRadio
});
module.exports = __toCommonJS(use_radio_exports);
var import_react = require("react");
var import_react2 = require("react");
var import_focus = require("@react-aria/focus");
var import_interactions = require("@react-aria/interactions");
var import_theme = require("@nextui-org/theme");
var import_radio = require("@react-aria/radio");
var import_shared_utils2 = require("@nextui-org/shared-utils");
var import_dom_utils = require("@nextui-org/dom-utils");
var import_utils = require("@react-aria/utils");

// src/radio-group-context.ts
var import_shared_utils = require("@nextui-org/shared-utils");
var [RadioGroupProvider, useRadioGroupContext] = (0, import_shared_utils.createContext)({
  name: "RadioGroupContext",
  strict: true,
  errorMessage: "useRadioGroupContext: `context` is undefined. Seems you forgot to wrap all checkbox components within `<Radio.Group />`"
});

// src/use-radio.ts
function useRadio(props) {
  var _a, _b, _c, _d, _e;
  const groupContext = useRadioGroupContext();
  const {
    as,
    ref,
    styles,
    id,
    value,
    children,
    description,
    size = (_a = groupContext == null ? void 0 : groupContext.size) != null ? _a : "md",
    color = (_b = groupContext == null ? void 0 : groupContext.color) != null ? _b : "primary",
    radius = (_c = groupContext == null ? void 0 : groupContext.radius) != null ? _c : "full",
    isDisabled: isDisabledProp = (_d = groupContext == null ? void 0 : groupContext.isDisabled) != null ? _d : false,
    disableAnimation = (_e = groupContext == null ? void 0 : groupContext.disableAnimation) != null ? _e : false,
    onChange = groupContext == null ? void 0 : groupContext.onChange,
    autoFocus = false,
    className,
    ...otherProps
  } = props;
  if (groupContext && import_shared_utils2.__DEV__) {
    if ("checked" in otherProps) {
      (0, import_shared_utils2.warn)('Remove props "checked" if in the Radio.Group.', "Radio");
    }
    if (value === void 0) {
      (0, import_shared_utils2.warn)('Props "value" must be defined if in the Radio.Group.', "Radio");
    }
  }
  const Component = as || "label";
  const domRef = (0, import_dom_utils.useDOMRef)(ref);
  const inputRef = (0, import_react2.useRef)(null);
  const labelId = (0, import_react.useId)();
  const isDisabled = (0, import_react2.useMemo)(() => !!isDisabledProp, [isDisabledProp]);
  const isRequired = (0, import_react2.useMemo)(() => {
    var _a2;
    return (_a2 = groupContext.isRequired) != null ? _a2 : false;
  }, [groupContext.isRequired]);
  const isInvalid = (0, import_react2.useMemo)(() => groupContext.validationState === "invalid", [
    groupContext.validationState
  ]);
  const ariaRadioProps = (0, import_react2.useMemo)(() => {
    const ariaLabel = otherProps["aria-label"] || typeof children === "string" ? children : void 0;
    const ariaDescribedBy = otherProps["aria-describedby"] || typeof description === "string" ? description : void 0;
    return {
      id,
      isDisabled,
      isRequired,
      "aria-label": ariaLabel,
      "aria-labelledby": otherProps["aria-labelledby"] || labelId,
      "aria-describedby": ariaDescribedBy
    };
  }, [labelId, id, isDisabled, isRequired]);
  const { inputProps } = (0, import_radio.useRadio)(
    {
      value,
      children,
      ...groupContext,
      ...ariaRadioProps
    },
    groupContext.groupState,
    inputRef
  );
  const isSelected = (0, import_react2.useMemo)(() => inputProps.checked, [inputProps.checked]);
  const { hoverProps, isHovered } = (0, import_interactions.useHover)({ isDisabled });
  const { focusProps, isFocused, isFocusVisible } = (0, import_focus.useFocusRing)({
    autoFocus
  });
  const slots = (0, import_react2.useMemo)(
    () => (0, import_theme.radio)({
      color,
      size,
      radius,
      isInvalid,
      isDisabled,
      isFocusVisible,
      disableAnimation
    }),
    [color, size, radius, isDisabled, isInvalid, isFocusVisible, disableAnimation]
  );
  const baseStyles = (0, import_shared_utils2.clsx)(styles == null ? void 0 : styles.base, className);
  const getBaseProps = (props2 = {}) => {
    return {
      ...props2,
      ref: domRef,
      className: slots.base({ class: baseStyles }),
      "data-disabled": (0, import_shared_utils2.dataAttr)(isDisabled),
      "data-checked": (0, import_shared_utils2.dataAttr)(inputProps.checked),
      "data-invalid": (0, import_shared_utils2.dataAttr)(isInvalid),
      ...(0, import_utils.mergeProps)(hoverProps, otherProps)
    };
  };
  const getWrapperProps = (props2 = {}) => {
    return {
      ...props2,
      "data-active": (0, import_shared_utils2.dataAttr)(isSelected),
      "data-hover": (0, import_shared_utils2.dataAttr)(isHovered),
      "data-hover-unchecked": (0, import_shared_utils2.dataAttr)(isHovered && !isSelected),
      "data-checked": (0, import_shared_utils2.dataAttr)(isSelected),
      "data-focus": (0, import_shared_utils2.dataAttr)(isFocused),
      "data-focus-visible": (0, import_shared_utils2.dataAttr)(isFocused && isFocusVisible),
      "data-disabled": (0, import_shared_utils2.dataAttr)(isDisabled),
      "data-invalid": (0, import_shared_utils2.dataAttr)(isInvalid),
      "data-readonly": (0, import_shared_utils2.dataAttr)(inputProps.readOnly),
      "aria-required": (0, import_shared_utils2.dataAttr)(isRequired),
      "aria-hidden": true,
      className: (0, import_shared_utils2.clsx)(slots.wrapper({ class: styles == null ? void 0 : styles.wrapper }))
    };
  };
  const getInputProps = (props2 = {}) => {
    return {
      ...props2,
      ref: inputRef,
      required: isRequired,
      "aria-required": (0, import_shared_utils2.dataAttr)(isRequired),
      "data-invalid": (0, import_shared_utils2.dataAttr)(isInvalid),
      "data-readonly": (0, import_shared_utils2.dataAttr)(inputProps.readOnly),
      ...(0, import_utils.mergeProps)(inputProps, focusProps),
      onChange: (0, import_utils.chain)(inputProps.onChange, onChange)
    };
  };
  const getLabelProps = (0, import_react.useCallback)(
    (props2 = {}) => ({
      ...props2,
      id: labelId,
      "data-disabled": (0, import_shared_utils2.dataAttr)(isDisabled),
      "data-checked": (0, import_shared_utils2.dataAttr)(isSelected),
      "data-invalid": (0, import_shared_utils2.dataAttr)(isInvalid),
      className: slots.label({ class: styles == null ? void 0 : styles.label })
    }),
    [slots, styles, isDisabled, isSelected, isInvalid]
  );
  const getLabelWrapperProps = (0, import_react.useCallback)(
    (props2 = {}) => ({
      ...props2,
      className: slots.labelWrapper({ class: styles == null ? void 0 : styles.labelWrapper })
    }),
    [slots, styles]
  );
  const getControlProps = (0, import_react.useCallback)(
    (props2 = {}) => ({
      ...props2,
      "data-disabled": (0, import_shared_utils2.dataAttr)(isDisabled),
      "data-checked": (0, import_shared_utils2.dataAttr)(isSelected),
      "data-invalid": (0, import_shared_utils2.dataAttr)(isInvalid),
      className: slots.control({ class: styles == null ? void 0 : styles.control })
    }),
    [slots, isDisabled, isSelected, isInvalid]
  );
  return {
    Component,
    children,
    slots,
    styles,
    description,
    isSelected,
    isDisabled,
    isInvalid,
    isFocusVisible,
    getBaseProps,
    getWrapperProps,
    getInputProps,
    getLabelProps,
    getLabelWrapperProps,
    getControlProps
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  useRadio
});
